<pre><?php
// scan all .md files, add header, footer and menu, make html

require_once('markdown.php');

// ----- 

function text2html($text)
{
  if(preg_match("/[\xc0-\xdf][\x80-\xbf]/", $text)) $text = utf8_decode($text);
  $html = htmlentities($text, ENT_HTML401 | ENT_NOQUOTES | ENT_IGNORE, "ISO-8859-1");
  $repl = array
  ( '&gt;' => '>',
    '&lt;' => '<'
  );
  $html = str_replace(array_keys($repl), array_values($repl), $html);
  return $html;
}

// ----- 

function process_md($dname, $head, $foot)
{
  $md = file_get_contents($dname);
  $html = Markdown(text2html($md));
  $oname = preg_replace('/\.md$/', '.html', $dname);
  
  file_put_contents($oname, "$head\n$html\n$foot");
}
// ----- 

function process_dir($dirname, $head, $foot, $menu)
{
  print "Process $dirname\n";
  
  $h = @file_get_contents("$dirname/header.inc");
  $f = @file_get_contents("$dirname/footer.inc");
  $m = @file_get_contents("$dirname/menu.inc");
  
  if($h > '') $head .= $h;
  if($f > '') $foot = $f . $foot;
  if($m > '') $menu .= $m;
  
  $myhead = str_replace('{{menu}}', $menu, $head);
  
  $dirlist = scandir($dirname);

  $subdirs = array();

  foreach($dirlist as $d)
  {
    if(substr($d,0,1) == '.') continue;
  
    if(is_dir($d))
    {
      $subdirs[] = $dirname . '/' . $d;
    }
    else if(substr($d, -3) == '.md')
    {
      $fname = "$dirname/$d";
      print "File: $fname\n";
      process_md($fname, $myhead, $foot);
    }
  }
  
  foreach($subdirs as $s) process_dir($s, $head, $foot, $menu);
}

// ----- 

process_dir('.', '', '', '');

?>
</pre>